diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/libioP.h libg++-2.5.3linux.2/libio/libioP.h
*** libg++-2.5.3/libio/libioP.h	Wed Dec 22 06:40:01 1993
--- libg++-2.5.3linux.2/libio/libioP.h	Sun Feb 13 22:03:08 1994
***************
*** 29,34 ****
--- 29,44 ----
  
  #include "iolibio.h"
  
+ /* Include those system dependent file. */
+ 
+ #ifdef _LIBIO_CONFIG_H
+ #include _LIBIO_CONFIG_H
+ #endif
+ 
+ #ifdef __STDC__
+ #include <stdlib.h>
+ #endif
+ 
  #ifdef __cplusplus
  extern "C" {
  #endif
***************
*** 42,68 ****
       read and write positions. */
    _IO_seek_not_in = 4,	/* Don't move read posistion. */
    _IO_seek_not_out = 8,	/* Don't move write posistion. */
!   _IO_seek_pos_ignored = 16 /* Result is ignored (except EOF) */
  } _IO_seekflags;
  
! typedef int (*_IO_overflow_t) _PARAMS((_IO_FILE*, int));
! typedef int (*_IO_underflow_t) _PARAMS((_IO_FILE*));
! typedef _IO_size_t (*_IO_xsputn_t) _PARAMS((_IO_FILE*,const void*,_IO_size_t));
! typedef _IO_size_t (*_IO_xsgetn_t) _PARAMS((_IO_FILE*, void*, _IO_size_t));
! typedef _IO_ssize_t (*_IO_read_t) _PARAMS((_IO_FILE*, void*, _IO_ssize_t));
! typedef _IO_ssize_t (*_IO_write_t) _PARAMS((_IO_FILE*,const void*,_IO_ssize_t));
! typedef int (*_IO_stat_t) _PARAMS((_IO_FILE*, void*));
! typedef _IO_fpos_t (*_IO_seek_t) _PARAMS((_IO_FILE*, _IO_off_t, int));
! typedef int (*_IO_doallocate_t) _PARAMS((_IO_FILE*));
! typedef int (*_IO_pbackfail_t) _PARAMS((_IO_FILE*, int));
! typedef int (*_IO_setbuf_t) _PARAMS((_IO_FILE*, char *, _IO_ssize_t));
! typedef int (*_IO_sync_t) _PARAMS((_IO_FILE*));
! typedef void (*_IO_finish_t) _PARAMS((_IO_FILE*)); /* finalize */
! typedef int (*_IO_close_t) _PARAMS((_IO_FILE*)); /* finalize */
! typedef _IO_fpos_t (*_IO_seekoff_t) _PARAMS((_IO_FILE*, _IO_off_t, _IO_seekflags));
  
  /* The _IO_seek_cur and _IO_seek_end options are not allowed. */
! typedef _IO_fpos_t (*_IO_seekpos_t) _PARAMS((_IO_FILE*, _IO_fpos_t, _IO_seekflags));
  
  struct _IO_jump_t {
      _IO_overflow_t __overflow;
--- 52,78 ----
       read and write positions. */
    _IO_seek_not_in = 4,	/* Don't move read posistion. */
    _IO_seek_not_out = 8,	/* Don't move write posistion. */
!   _IO_seek_pos_ignored = 16, /* Result is ignored (except EOF) */
  } _IO_seekflags;
  
! typedef int (*_IO_overflow_t) __P((_IO_FILE*, int));
! typedef int (*_IO_underflow_t) __P((_IO_FILE*));
! typedef _IO_size_t (*_IO_xsputn_t) __P((_IO_FILE*,const void*,_IO_size_t));
! typedef _IO_size_t (*_IO_xsgetn_t) __P((_IO_FILE*, void*, _IO_size_t));
! typedef _IO_ssize_t (*_IO_read_t) __P((_IO_FILE*, void*, _IO_ssize_t));
! typedef _IO_ssize_t (*_IO_write_t) __P((_IO_FILE*,const void*,_IO_ssize_t));
! typedef int (*_IO_stat_t) __P((_IO_FILE*, void*));
! typedef _IO_fpos_t (*_IO_seek_t) __P((_IO_FILE*, _IO_off_t, int));
! typedef int (*_IO_doallocate_t) __P((_IO_FILE*));
! typedef int (*_IO_pbackfail_t) __P((_IO_FILE*, int));
! typedef int (*_IO_setbuf_t) __P((_IO_FILE*, char *, _IO_ssize_t));
! typedef int (*_IO_sync_t) __P((_IO_FILE*));
! typedef void (*_IO_finish_t) __P((_IO_FILE*)); /* finalize */
! typedef int (*_IO_close_t) __P((_IO_FILE*)); /* finalize */
! typedef _IO_fpos_t (*_IO_seekoff_t) __P((_IO_FILE*, _IO_off_t, _IO_seekflags));
  
  /* The _IO_seek_cur and _IO_seek_end options are not allowed. */
! typedef _IO_fpos_t (*_IO_seekpos_t) __P((_IO_FILE*, _IO_fpos_t, _IO_seekflags));
  
  struct _IO_jump_t {
      _IO_overflow_t __overflow;
***************
*** 89,141 ****
  
  /* Generic functions */
  
! extern _IO_fpos_t _IO_seekoff _PARAMS((_IO_FILE*, _IO_off_t, _IO_seekflags));
! extern _IO_fpos_t _IO_seekpos _PARAMS((_IO_FILE*, _IO_fpos_t, _IO_seekflags));
  
! extern int _IO_switch_to_get_mode _PARAMS((_IO_FILE*));
! extern void _IO_init _PARAMS((_IO_FILE*, int));
! extern int _IO_sputbackc _PARAMS((_IO_FILE*, int));
! extern int _IO_sungetc _PARAMS((_IO_FILE*));
! extern void _IO_un_link _PARAMS((_IO_FILE*));
! extern void _IO_link_in _PARAMS((_IO_FILE *));
! extern void _IO_doallocbuf _PARAMS((_IO_FILE*));
! extern void _IO_unsave_markers _PARAMS((_IO_FILE*));
! extern void _IO_setb _PARAMS((_IO_FILE*, char*, char*, int));
! extern unsigned _IO_adjust_column _PARAMS((unsigned, const char *, int));
  #define _IO_sputn(__fp, __s, __n) (__fp->_jumps->__xsputn(__fp, __s, __n))
  
  /* Marker-related function. */
  
! extern void _IO_init_marker _PARAMS((struct _IO_marker *, _IO_FILE *));
! extern void _IO_remove_marker _PARAMS((struct _IO_marker*));
! extern int _IO_marker_difference _PARAMS((struct _IO_marker *, struct _IO_marker *));
! extern int _IO_marker_delta _PARAMS((struct _IO_marker *));
! extern int _IO_seekmark _PARAMS((_IO_FILE *, struct _IO_marker *, int));
  
  /* Default jumptable functions. */
  
! extern int _IO_default_underflow _PARAMS((_IO_FILE*));
! extern int _IO_default_doallocate _PARAMS((_IO_FILE*));
! extern void _IO_default_finish _PARAMS((_IO_FILE *));
! extern int _IO_default_pbackfail _PARAMS((_IO_FILE*, int));
! extern int _IO_default_setbuf _PARAMS((_IO_FILE *, char*, _IO_ssize_t));
! extern _IO_size_t _IO_default_xsputn _PARAMS((_IO_FILE *, const void*, _IO_size_t));
! extern _IO_size_t _IO_default_xsgetn _PARAMS((_IO_FILE *, void*, _IO_size_t));
! extern _IO_fpos_t _IO_default_seekoff _PARAMS((_IO_FILE*, _IO_off_t, _IO_seekflags));
! extern _IO_fpos_t _IO_default_seekpos _PARAMS((_IO_FILE*, _IO_fpos_t, _IO_seekflags));
! extern _IO_ssize_t _IO_default_write _PARAMS((_IO_FILE*,const void*,_IO_ssize_t));
! extern _IO_ssize_t _IO_default_read _PARAMS((_IO_FILE*, void*, _IO_ssize_t));
! extern int _IO_default_stat _PARAMS((_IO_FILE*, void*));
! extern _IO_fpos_t _IO_default_seek _PARAMS((_IO_FILE*, _IO_off_t, int));
! extern int _IO_default_sync _PARAMS((_IO_FILE*));
  #define _IO_default_close ((_IO_close_t)_IO_default_sync)
  
  extern struct _IO_jump_t _IO_file_jumps;
  extern struct _IO_jump_t _IO_proc_jumps;
  extern struct _IO_jump_t _IO_str_jumps;
! extern int _IO_do_write _PARAMS((_IO_FILE*, const char*, _IO_size_t));
! extern int _IO_flush_all _PARAMS(());
! extern void _IO_flush_all_linebuffered _PARAMS(());
  
  #define _IO_do_flush(_f) \
    _IO_do_write(_f, _f->_IO_write_base, _f->_IO_write_ptr-_f->_IO_write_base)
--- 99,160 ----
  
  /* Generic functions */
  
! extern _IO_fpos_t _IO_seekoff __P((_IO_FILE*, _IO_off_t, _IO_seekflags));
! extern _IO_fpos_t _IO_seekpos __P((_IO_FILE*, _IO_fpos_t, _IO_seekflags));
  
! extern int _IO_switch_to_get_mode __P((_IO_FILE*));
! extern void _IO_init __P((_IO_FILE*, int));
! extern int _IO_sputbackc __P((_IO_FILE*, int));
! extern int _IO_sungetc __P((_IO_FILE*));
! extern void _IO_un_link __P((_IO_FILE*));
! extern void _IO_link_in __P((_IO_FILE *));
! extern void _IO_doallocbuf __P((_IO_FILE*));
! extern void _IO_unsave_markers __P((_IO_FILE*));
! extern void _IO_setb __P((_IO_FILE*, char*, char*, int));
! extern unsigned _IO_adjust_column __P((unsigned, const char *, int));
  #define _IO_sputn(__fp, __s, __n) (__fp->_jumps->__xsputn(__fp, __s, __n))
  
+ extern int _IO_ignore __P((_IO_FILE *, _IO_size_t));
+ extern void _IO_switch_to_main_get_area __P((_IO_FILE *));
+ extern void _IO_switch_to_backup_area  __P((_IO_FILE *));
+ extern int _IO_sync __P((_IO_FILE *));
+ extern int _IO_get_column __P((_IO_FILE *));
+ extern int _IO_set_column __P((_IO_FILE *, int));
+ extern int _IO_nobackup_pbackfail __P((_IO_FILE *, int));
+ 
  /* Marker-related function. */
  
! extern void _IO_init_marker __P((struct _IO_marker *, _IO_FILE *));
! extern void _IO_remove_marker __P((struct _IO_marker*));
! extern int _IO_marker_difference __P((struct _IO_marker *, struct _IO_marker *));
! extern int _IO_marker_delta __P((struct _IO_marker *));
! extern int _IO_seekmark __P((_IO_FILE *, struct _IO_marker *, int));
! extern _IO_size_t _IO_least_marker __P((_IO_FILE *));
  
  /* Default jumptable functions. */
  
! extern int _IO_default_underflow __P((_IO_FILE*));
! extern int _IO_default_doallocate __P((_IO_FILE*));
! extern void _IO_default_finish __P((_IO_FILE *));
! extern int _IO_default_pbackfail __P((_IO_FILE*, int));
! extern int _IO_default_setbuf __P((_IO_FILE *, char*, _IO_ssize_t));
! extern _IO_size_t _IO_default_xsputn __P((_IO_FILE *, const void*, _IO_size_t));
! extern _IO_size_t _IO_default_xsgetn __P((_IO_FILE *, void*, _IO_size_t));
! extern _IO_fpos_t _IO_default_seekoff __P((_IO_FILE*, _IO_off_t, _IO_seekflags));
! extern _IO_fpos_t _IO_default_seekpos __P((_IO_FILE*, _IO_fpos_t, _IO_seekflags));
! extern _IO_ssize_t _IO_default_write __P((_IO_FILE*,const void*,_IO_ssize_t));
! extern _IO_ssize_t _IO_default_read __P((_IO_FILE*, void*, _IO_ssize_t));
! extern int _IO_default_stat __P((_IO_FILE*, void*));
! extern _IO_fpos_t _IO_default_seek __P((_IO_FILE*, _IO_off_t, int));
! extern int _IO_default_sync __P((_IO_FILE*));
  #define _IO_default_close ((_IO_close_t)_IO_default_sync)
  
  extern struct _IO_jump_t _IO_file_jumps;
  extern struct _IO_jump_t _IO_proc_jumps;
  extern struct _IO_jump_t _IO_str_jumps;
! extern int _IO_do_write __P((_IO_FILE*, const char*, _IO_size_t));
! extern int _IO_flush_all __P((void));
! extern void _IO_flush_all_linebuffered __P((void));
  
  #define _IO_do_flush(_f) \
    _IO_do_write(_f, _f->_IO_write_base, _f->_IO_write_ptr-_f->_IO_write_base)
***************
*** 153,205 ****
  
  /* Jumptable functions for files. */
  
! extern int _IO_file_doallocate _PARAMS((_IO_FILE*));
! extern int _IO_file_setbuf _PARAMS((_IO_FILE *, char*, _IO_ssize_t));
! extern _IO_fpos_t _IO_file_seekoff _PARAMS((_IO_FILE*, _IO_off_t, _IO_seekflags));
! extern _IO_size_t _IO_file_xsputn _PARAMS((_IO_FILE*,const void*,_IO_size_t));
! extern int _IO_file_stat _PARAMS((_IO_FILE*, void*));
! extern int _IO_file_close _PARAMS((_IO_FILE*));
! extern int _IO_file_underflow _PARAMS((_IO_FILE *));
! extern int _IO_file_overflow _PARAMS((_IO_FILE *, int));
  #define _IO_file_is_open(__fp) ((__fp)->_fileno >= 0)
! extern void _IO_file_init _PARAMS((_IO_FILE*));
! extern _IO_FILE* _IO_file_attach _PARAMS((_IO_FILE*, int));
! extern _IO_FILE* _IO_file_fopen _PARAMS((_IO_FILE*, const char*, const char*));
! extern _IO_ssize_t _IO_file_write _PARAMS((_IO_FILE*,const void*,_IO_ssize_t));
! extern _IO_ssize_t _IO_file_read _PARAMS((_IO_FILE*, void*, _IO_ssize_t));
! extern int _IO_file_sync _PARAMS((_IO_FILE*));
! extern int _IO_file_close_it _PARAMS((_IO_FILE*));
! extern _IO_fpos_t _IO_file_seek _PARAMS((_IO_FILE *, _IO_off_t, int));
! extern void _IO_file_finish _PARAMS((_IO_FILE*));
  
  /* Other file functions. */
! extern _IO_FILE* _IO_file_attach _PARAMS((_IO_FILE *, int));
  
  /* Jumptable functions for proc_files. */
! extern _IO_FILE* _IO_proc_open _PARAMS((_IO_FILE*, const char*, const char *));
! extern int _IO_proc_close _PARAMS((_IO_FILE*));
  
  /* Jumptable functions for strfiles. */
! extern int _IO_str_underflow _PARAMS((_IO_FILE*));
! extern int _IO_str_overflow _PARAMS((_IO_FILE *, int));
! extern int _IO_str_pbackfail _PARAMS((_IO_FILE*, int));
! extern _IO_fpos_t _IO_str_seekoff _PARAMS((_IO_FILE*,_IO_off_t,_IO_seekflags));
  
  /* Other strfile functions */
! extern void _IO_str_init_static _PARAMS((_IO_FILE *, char*, int, char*));
! extern void _IO_str_init_readonly _PARAMS((_IO_FILE *, const char*, int));
! extern _IO_ssize_t _IO_str_count _PARAMS ((_IO_FILE*));
! 
! extern _IO_size_t _IO_getline _PARAMS((_IO_FILE*,char*,_IO_size_t,int,int));
! extern double _IO_strtod _PARAMS((const char *, char **));
! extern char * _IO_dtoa _PARAMS((double __d, int __mode, int __ndigits,
  				int *__decpt, int *__sign, char **__rve));
! extern int _IO_outfloat _PARAMS((double __value, _IO_FILE *__sb, int __type,
  				 int __width, int __precision, int __flags,
  				 int __sign_mode, int __fill));
  
  extern _IO_FILE *_IO_list_all;
  extern void (*_IO_cleanup_registration_needed)();
  
  #ifndef EOF
  #define EOF (-1)
--- 172,232 ----
  
  /* Jumptable functions for files. */
  
! extern int _IO_file_doallocate __P((_IO_FILE*));
! extern int _IO_file_setbuf __P((_IO_FILE *, char*, _IO_ssize_t));
! extern _IO_fpos_t _IO_file_seekoff __P((_IO_FILE*, _IO_off_t, _IO_seekflags));
! extern _IO_size_t _IO_file_xsputn __P((_IO_FILE*,const void*,_IO_size_t));
! extern int _IO_file_stat __P((_IO_FILE*, void*));
! extern int _IO_file_close __P((_IO_FILE*));
! extern int _IO_file_underflow __P((_IO_FILE *));
! extern int _IO_file_overflow __P((_IO_FILE *, int));
  #define _IO_file_is_open(__fp) ((__fp)->_fileno >= 0)
! extern void _IO_file_init __P((_IO_FILE*));
! extern _IO_FILE* _IO_file_attach __P((_IO_FILE*, int));
! extern _IO_FILE* _IO_file_fopen __P((_IO_FILE*, const char*, const char*));
! extern _IO_ssize_t _IO_file_write __P((_IO_FILE*,const void*,_IO_ssize_t));
! extern _IO_ssize_t _IO_file_read __P((_IO_FILE*, void*, _IO_ssize_t));
! extern int _IO_file_sync __P((_IO_FILE*));
! extern int _IO_file_close_it __P((_IO_FILE*));
! extern _IO_fpos_t _IO_file_seek __P((_IO_FILE *, _IO_off_t, int));
! extern void _IO_file_finish __P((_IO_FILE*));
  
  /* Other file functions. */
! extern _IO_FILE* _IO_file_attach __P((_IO_FILE *, int));
  
  /* Jumptable functions for proc_files. */
! extern _IO_FILE* _IO_proc_open __P((_IO_FILE*, const char*, const char *));
! extern int _IO_proc_close __P((_IO_FILE*));
  
  /* Jumptable functions for strfiles. */
! extern int _IO_str_underflow __P((_IO_FILE*));
! extern int _IO_str_overflow __P((_IO_FILE *, int));
! extern int _IO_str_pbackfail __P((_IO_FILE*, int));
! extern _IO_fpos_t _IO_str_seekoff __P((_IO_FILE*,_IO_off_t,_IO_seekflags));
  
  /* Other strfile functions */
! extern void _IO_str_init_static __P((_IO_FILE *, char*, int, char*));
! extern void _IO_str_init_readonly __P((_IO_FILE *, const char*, int));
! extern _IO_ssize_t _IO_str_count __P ((_IO_FILE*));
! extern void _IO_str_finish __P((_IO_FILE *));
! 
! extern _IO_size_t _IO_getline __P((_IO_FILE*,char*,_IO_size_t,int,int));
! extern double _IO_strtod __P((const char *, char **));
! extern char * _IO_dtoa __P((double __d, int __mode, int __ndigits,
  				int *__decpt, int *__sign, char **__rve));
! extern int _IO_outfloat __P((double __value, _IO_FILE *__sb, int __type,
  				 int __width, int __precision, int __flags,
  				 int __sign_mode, int __fill));
  
+ extern char *_IO_gen_tempname __P ((const char *__dir,
+ 				 const char *__pfx, int __dir_search,
+ 				 _IO_size_t * __lenptr,
+ 				 _IO_FILE **__streamptr));
+  
  extern _IO_FILE *_IO_list_all;
+ #ifndef __linux__
  extern void (*_IO_cleanup_registration_needed)();
+ #endif
  
  #ifndef EOF
  #define EOF (-1)
***************
*** 219,229 ****
  #define OS_FSTAT fstat
  #endif
  struct stat;
! extern _IO_ssize_t _IO_read _PARAMS((int, void*, _IO_size_t));
! extern _IO_ssize_t _IO_write _PARAMS((int, const void*, _IO_size_t));
! extern _IO_off_t _IO_lseek _PARAMS((int, _IO_off_t, int));
! extern int _IO_close _PARAMS((int));
! extern int _IO_fstat _PARAMS((int, struct stat *));
  
  /* Operations on _IO_fpos_t.
     Normally, these are trivial, but we provide hooks for configurations
--- 246,256 ----
  #define OS_FSTAT fstat
  #endif
  struct stat;
! extern _IO_ssize_t _IO_read __P((int, void*, _IO_size_t));
! extern _IO_ssize_t _IO_write __P((int, const void*, _IO_size_t));
! extern _IO_off_t _IO_lseek __P((int, _IO_off_t, int));
! extern int _IO_close __P((int));
! extern int _IO_fstat __P((int, struct stat *));
  
  /* Operations on _IO_fpos_t.
     Normally, these are trivial, but we provide hooks for configurations
***************
*** 257,262 ****
--- 284,320 ----
  #define _IO_va_start(args, last) va_start(args)
  #endif
  
+ /* Just do a sanity check. We assume no one uses old stdio. It
+  * won't work all the time.
+  */
+ #if 1
+ #ifdef EIO
+ #define CHECK_FILE(FILE,RET) \
+ 	if ((FILE) == NULL || \
+ 		((FILE)->_IO_file_flags & _IO_MAGIC_MASK) != _IO_MAGIC) \
+ 	{ errno = EIO; return RET; }
+ #else
+ #define CHECK_FILE(FILE,RET) \
+ 	if ((FILE) == NULL || \
+ 		((FILE)->_IO_file_flags & _IO_MAGIC_MASK) != _IO_MAGIC) \
+ 	{ return RET; }
+ #endif
+ #else
+ #ifdef EIO
+ #define CHECK_FILE(FILE,RET) \
+ 	if ((FILE) == NULL || ( \
+ 		((FILE)->_IO_file_flags & _IO_MAGIC_MASK) != _IO_MAGIC \
+ 		&& ((FILE)->_IO_file_flags & _IO_MAGIC_MASK) != _OLD_IO_MAGIC)) \
+ 	{ errno = EIO; return RET; }
+ #else
+ #define CHECK_FILE(FILE,RET) \
+ 	if ((FILE) == NULL || ( \
+ 		((FILE)->_IO_file_flags & _IO_MAGIC_MASK) != _IO_MAGIC \
+ 		&& ((FILE)->_IO_file_flags & _IO_MAGIC_MASK) != _OLD_IO_MAGIC)) \
+ 	{ return RET; }
+ #endif
+ #endif
+ 
  #if 1
  #define COERCE_FILE(FILE) /* Nothing */
  #else
***************
*** 265,267 ****
--- 323,328 ----
    (((FILE)->_IO_file_flags & _IO_MAGIC_MASK) == _OLD_MAGIC_MASK \
      && (FILE) = *(FILE**)&((int*)fp)[1])
  #endif
+ 
+ #define CLOSED_FILEBUF_FLAGS \
+   (_IO_IS_FILEBUF+_IO_NO_READS+_IO_NO_WRITES+_IO_TIED_PUT_GET)
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/procbuf.h libg++-2.5.3linux.2/libio/procbuf.h
*** libg++-2.5.3/libio/procbuf.h	Fri Oct 22 00:54:38 1993
--- libg++-2.5.3linux.2/libio/procbuf.h	Mon Dec 20 08:54:32 1993
***************
*** 29,34 ****
--- 29,35 ----
  class procbuf : public filebuf {
      /* Following fields must match those in struct _IO_proc_file */
      _IO_pid_t _pid;
+     struct _IO_proc_file *_next;
    public:
      procbuf() : filebuf() { }
      procbuf(const char *command, int mode);
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/ChangeLog libg++-2.5.3linux.2/libio/stdio/ChangeLog
*** libg++-2.5.3/libio/stdio/ChangeLog	Fri Nov 26 21:48:20 1993
--- libg++-2.5.3linux.2/libio/stdio/ChangeLog	Mon Feb 14 10:09:18 1994
***************
*** 1,3 ****
--- 1,66 ----
+ Sat Jan  1 21:13:59 1994  H.J. Lu (hlu@nighthawk)
+ 
+ 	* clearerr.c:
+ 	* feof.c:
+ 	* ferror.c:
+ 	* fgetc.c:
+ 	* fileno.c:
+ 	* fputc.c:
+ 	* freopen.c:
+ 	* fseek.c:
+ 	* getw.c:
+ 	* putw.c:
+ 	* rewind.c:
+ 	* setfileno.c:
+ 	* vfprintf.c:
+ 	* vfscanf.c: check fp with CHECK_FILE(FILE,RET).
+ 
+ Sun Dec 19 12:36:10 1993  H.J. Lu (hlu@nighthawk)
+ 
+         * stdio.h: don't define __P since it is taken care of
+ 	  in libio.h. change const to __const.
+ 		   
+ Thu Dec  2 22:25:31 1993  H.J. Lu (hlu@nighthawk)
+ 
+ 	* Makefile.in (STDIO_OBJECTS): add stdio.o, remove.o, tmpfile.o
+ 	  and tmpnam.o.  change popen.o to pclose.o.
+ 
+ 	* stdio.h: include <features.h> if __linux__ is defined.
+ 	  <features.h> should be copied from glibc to help put libio
+ 	  into glibc.
+ 	  change _ARGS to __P.
+ 	  check if __P is already defined.
+ 	  declare psignal (), _sys_errlist, _sys_siglist if
+ 	  __GNU_LIBRARY__ is defined.
+ 	  add getw () and putw ().
+ 	  (getc, getchar, putc, putchar): new declaration. move macros after
+ 	  the declaration.
+ 	  (tempnam): new declaration.
+ 	  define TMP_MAX as 238328. see ../iotempname.c.
+ 
+ 	* popen.c: removed.
+ 
+ 	* pclose.c: renamed from popen.c.
+ 
+ 	* stdio.c: new file for stdin, stdout and stderr.
+ 
+ 	* vfprintf.c:
+ 	* fdopen.c: add alias for Linux.
+ 
+ 	* remove.c: new file for remove ().
+ 
+ 	* tempnam.c: new file for tempnam ().
+ 
+ 	* tmpfile.c: new file for tmpfile ().
+ 
+ 	* tmpnam.c: new file for tmpnam ().
+ 
+ 	* configure.in: Linux uses aliases instead of
+ 	  -D_IO_foo=foo. Move #define _HAVE_GNU_LD to the
+ 	  first line.
+ 	  remove the TODO list. rename () should be a system call.
+ 	  (stdio_renames): add popen if __linux__ is defined.
+ 
  Fri Nov 26 13:26:35 1993  Per Bothner  (bothner@kalessin.cygnus.com)
  
  	Bunch of little changes, many from H.J. Lu <hjl@nynexst.com>.
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/clearerr.c libg++-2.5.3linux.2/libio/stdio/clearerr.c
*** libg++-2.5.3/libio/stdio/clearerr.c	Mon Oct  4 20:39:42 1993
--- libg++-2.5.3linux.2/libio/stdio/clearerr.c	Tue Jan 18 11:20:58 1994
***************
*** 5,10 ****
--- 5,11 ----
  clearerr(fp)
       FILE* fp;
  {
+   CHECK_FILE(fp, );
    COERCE_FILE(fp);
    _IO_clearerr(fp);
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/configure.in libg++-2.5.3linux.2/libio/stdio/configure.in
*** libg++-2.5.3/libio/stdio/configure.in	Thu Oct 14 19:13:08 1993
--- libg++-2.5.3linux.2/libio/stdio/configure.in	Mon Dec 20 08:54:33 1993
***************
*** 24,43 ****
  # NOTE: We assume a C compiler that where -o with -c works.
  # But these files are not built by default anyway ...
  
- # TODO: remove rename tmpfile tmpnam
- 
  stdio_renames="fclose fflush fgetpos fgets fopen fprintf fputs fread \
    fscanf fsetpos ftell fwrite gets perror printf puts \
    scanf setbuffer setvbuf sprintf sscanf ungetc vsprintf vsscanf"
  stdio_objects=""
  
! for file in $stdio_renames ; do
!   cat >>Makefile <<EOF
  $file.o: \$(srcdir)/../io$file.c
  	\$(CC_FOR_STDIO) \$(CFLAGS) \$(CINCLUDES) -c \\
  	  \$(srcdir)/../io$file.c -D_IO_$file=$file -o $file.o
  EOF
!   stdio_objects="$stdio_objects $file.o"
! done
  sed -e "/STDIO_RENAMED_OBJECTS =/s/=.*/=${stdio_objects}/" <Makefile >tmp
  mv -f tmp Makefile
--- 24,62 ----
  # NOTE: We assume a C compiler that where -o with -c works.
  # But these files are not built by default anyway ...
  
  stdio_renames="fclose fflush fgetpos fgets fopen fprintf fputs fread \
    fscanf fsetpos ftell fwrite gets perror printf puts \
    scanf setbuffer setvbuf sprintf sscanf ungetc vsprintf vsscanf"
  stdio_objects=""
  
! case "${target}" in
! *linux*)
!   # Linux uses aliases.
!   stdio_renames="$stdio_renames popen"
!   for file in $stdio_renames ; do
!     cat >>Makefile <<EOF
! $file.o:
! 	echo "#undef HAVE_GNU_LD" > $file.c
! 	echo "#define HAVE_GNU_LD" >> $file.c
! 	echo "#include <gnu-stabs.h>" >> $file.c
! 	echo "#undef $file" >> $file.c
! 	echo "symbol_alias (_IO_$file, $file);" >> $file.c
! 	\$(CC_FOR_STDIO) \$(CFLAGS) \$(CINCLUDES) -c $file.c
! 	/bin/rm -f $file.c
! EOF
!     stdio_objects="$stdio_objects $file.o"
!   done
!   ;;
! 
! *-*-*)
!   for file in $stdio_renames ; do
!     cat >>Makefile <<EOF
  $file.o: \$(srcdir)/../io$file.c
  	\$(CC_FOR_STDIO) \$(CFLAGS) \$(CINCLUDES) -c \\
  	  \$(srcdir)/../io$file.c -D_IO_$file=$file -o $file.o
  EOF
!     stdio_objects="$stdio_objects $file.o"
!   done
! esac
  sed -e "/STDIO_RENAMED_OBJECTS =/s/=.*/=${stdio_objects}/" <Makefile >tmp
  mv -f tmp Makefile
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/fdopen.c libg++-2.5.3linux.2/libio/stdio/fdopen.c
*** libg++-2.5.3/libio/stdio/fdopen.c	Fri Aug 20 01:59:58 1993
--- libg++-2.5.3linux.2/libio/stdio/fdopen.c	Mon Dec 20 08:54:33 1993
***************
*** 1,5 ****
--- 1,15 ----
  #include "libioP.h"
  
+ #ifdef __linux__
+  
+ #undef HAVE_GNU_LD
+ #define HAVE_GNU_LD
+ #include <gnu-stabs.h>
+   
+ symbol_alias (_IO_fdopen, fdopen);
+    
+ #else
+ 
  _IO_FILE *
  fdopen (fd, mode)
       int fd;
***************
*** 7,9 ****
--- 17,21 ----
  {
    return _IO_fdopen (fd, mode);
  }
+ 
+ #endif
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/feof.c libg++-2.5.3linux.2/libio/stdio/feof.c
*** libg++-2.5.3/libio/stdio/feof.c	Fri Nov 26 21:48:22 1993
--- libg++-2.5.3linux.2/libio/stdio/feof.c	Tue Jan 18 11:20:58 1994
***************
*** 29,34 ****
--- 29,35 ----
  feof(fp)
       _IO_FILE* fp;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    return _IO_feof(fp);
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/ferror.c libg++-2.5.3linux.2/libio/stdio/ferror.c
*** libg++-2.5.3/libio/stdio/ferror.c	Sat Nov 27 01:34:24 1993
--- libg++-2.5.3linux.2/libio/stdio/ferror.c	Tue Jan 18 11:20:58 1994
***************
*** 5,10 ****
--- 5,11 ----
  ferror(fp)
       FILE* fp;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    return _IO_ferror(fp);
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/fgetc.c libg++-2.5.3linux.2/libio/stdio/fgetc.c
*** libg++-2.5.3/libio/stdio/fgetc.c	Mon Oct  4 20:39:48 1993
--- libg++-2.5.3linux.2/libio/stdio/fgetc.c	Mon Feb 14 10:07:38 1994
***************
*** 5,10 ****
--- 5,11 ----
  fgetc(fp)
       FILE *fp;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    return _IO_getc(fp);
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/fileno.c libg++-2.5.3linux.2/libio/stdio/fileno.c
*** libg++-2.5.3/libio/stdio/fileno.c	Fri Nov 26 21:48:23 1993
--- libg++-2.5.3linux.2/libio/stdio/fileno.c	Tue Jan 18 11:20:58 1994
***************
*** 5,10 ****
--- 5,11 ----
  fileno(fp)
       _IO_FILE* fp;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    if (!(fp->_flags & _IO_IS_FILEBUF))
      return EOF;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/fputc.c libg++-2.5.3linux.2/libio/stdio/fputc.c
*** libg++-2.5.3/libio/stdio/fputc.c	Fri Nov 26 21:48:23 1993
--- libg++-2.5.3linux.2/libio/stdio/fputc.c	Mon Feb 14 10:07:48 1994
***************
*** 6,11 ****
--- 6,12 ----
       int c;
       FILE *fp;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    return _IO_putc(c, fp);
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/freopen.c libg++-2.5.3linux.2/libio/stdio/freopen.c
*** libg++-2.5.3/libio/stdio/freopen.c	Mon Oct  4 20:39:54 1993
--- libg++-2.5.3linux.2/libio/stdio/freopen.c	Sun Feb 13 22:23:04 1994
***************
*** 7,12 ****
--- 7,13 ----
       const char* mode;
       FILE* fp;
  {
+   CHECK_FILE(fp, NULL);
    COERCE_FILE(fp);
    if (!(fp->_flags & _IO_IS_FILEBUF))
      return NULL;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/fseek.c libg++-2.5.3linux.2/libio/stdio/fseek.c
*** libg++-2.5.3/libio/stdio/fseek.c	Fri Nov 26 21:48:24 1993
--- libg++-2.5.3linux.2/libio/stdio/fseek.c	Sun Feb 13 22:24:04 1994
***************
*** 7,12 ****
--- 7,13 ----
       long int offset;
       int whence;
  {
+   CHECK_FILE(fp, -1);
    COERCE_FILE(fp);
    return _IO_fseek(fp, offset, whence);
  }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/getw.c libg++-2.5.3linux.2/libio/stdio/getw.c
*** libg++-2.5.3/libio/stdio/getw.c	Fri Nov 26 21:48:27 1993
--- libg++-2.5.3linux.2/libio/stdio/getw.c	Mon Feb 14 10:08:08 1994
***************
*** 7,12 ****
--- 7,13 ----
  {
    int w;
    _IO_size_t bytes_read;
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    bytes_read = _IO_sgetn (fp, (char*)&w, sizeof(w));
    return sizeof(w) == bytes_read ? w : EOF;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/pclose.c libg++-2.5.3linux.2/libio/stdio/pclose.c
*** libg++-2.5.3/libio/stdio/pclose.c	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/stdio/pclose.c	Mon Dec 20 08:54:33 1993
***************
*** 0 ****
--- 1,27 ----
+ #include "libioP.h"
+ #include "stdio.h"
+ #include <errno.h>
+ 
+ #ifndef __linux__
+ 
+ FILE *
+ popen(command, mode)
+      const char *command; const char *mode;
+ {
+   return _IO_popen(command, mode);
+ }
+ 
+ #endif
+ 
+ int
+ pclose(fp)
+      FILE *fp;
+ {
+ #if 0
+   /* Does not actually test that stream was created by popen(). Instead,
+      it depends on the filebuf::sys_close() virtual to Do The Right Thing. */
+   if (fp is not a proc_file)
+     return -1;
+ #endif
+   return _IO_fclose(fp);
+ }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/putw.c libg++-2.5.3linux.2/libio/stdio/putw.c
*** libg++-2.5.3/libio/stdio/putw.c	Fri Nov 26 21:48:30 1993
--- libg++-2.5.3linux.2/libio/stdio/putw.c	Mon Feb 14 10:08:54 1994
***************
*** 9,14 ****
--- 9,15 ----
       FILE *fp;
  {
    _IO_size_t written;
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    written = _IO_sputn(fp, (const char *)&w, sizeof(w));
    return written == sizeof(w) ? 0 : EOF;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/remove.c libg++-2.5.3linux.2/libio/stdio/remove.c
*** libg++-2.5.3/libio/stdio/remove.c	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/stdio/remove.c	Mon Dec 20 08:54:34 1993
***************
*** 0 ****
--- 1,39 ----
+ /* Copyright (C) 1991 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+ 
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public License as
+ published by the Free Software Foundation; either version 2 of the
+ License, or (at your option) any later version.
+ 
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ 
+ You should have received a copy of the GNU Library General Public
+ License along with the GNU C Library; see the file COPYING.LIB.  If
+ not, write to the Free Software Foundation, Inc., 675 Mass Ave,
+ Cambridge, MA 02139, USA.  */
+ 
+ #include "libioP.h"
+ #include "stdio.h"
+ #include <unistd.h>
+ 
+ #ifdef __GNU_LIBRARY__
+ #include <ansidecl.h>
+ #include <gnu-stabs.h>
+ 
+ function_alias(remove, __unlink, int, (file),
+ 	       DEFUN(remove, (file), CONST char *file))
+ 
+ #else
+ 
+ int
+ remove (file)
+   const char *file;
+ {
+   return unlink (file);
+ }
+ 
+ #endif
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/stdio/rewind.c libg++-2.5.3linux.2/libio/stdio/rewind.c
*** libg++-2.5.3/libio/stdio/rewind.c	Fri Nov 26 21:48:31 1993
--- libg++-2.5.3linux.2/libio/stdio/rewind.c	Tue Jan 18 11:20:59 1994
***************
*** 5,10 ****
--- 5,11 ----
  rewind(fp)
       _IO_FILE* fp;
  {
+   CHECK_FILE(fp, );
    COERCE_FILE(fp);
    _IO_rewind(fp);
  }
